> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tangoanalytics.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Post reservationsrecurring datescalculate last date

> This operation calculates the end date for the given Recurrence Rule provided and returns the corresponding AqDate value.

If the recurrence rule is has no end date, an AqNoEndDate value is returned.

This operation requires a Recurrence Rule value.

This operation returns an AqDate value.



## OpenAPI

````yaml /tango_reserve/integrations/guides/aq-api.yaml post /reservations/recurring-dates/calculate-last-date
openapi: 3.1.0
info:
  description: phoenix-restful
  version: '2.0'
  title: Reserve Rest API
servers:
  - url: /aq-api/
security: []
tags:
  - name: AccountService
    description: |-
      Account Service

      The Accounts service provides an interface for business customer accounts
      whose intent includes creating resources which may be reserved in a public
      or private space.
  - name: AnalyticsGatewayService
    description: |-
      Provides gateway interface into analytic reports generated from Phoenix
      data.
  - name: ApplicationService
    description: >-
      Application Service


      Provides operations for creating and managing external applications which
      may interact with

      the Agilquest Forums platform.
  - name: ApprovalsService
    description: Base class for RESTful services.
  - name: AvailabilityService
    description: >-
      Availability Service


      Exposes operations which provide availability information for Assets
      within Agilquest Forums.
  - name: CacheReadinessService
  - name: ChargeCodeService
    description: |-
      Charge Code Service

      The Charge Code Service provides the RESTful end points for interacting
      with Charge Codes in the Agilquest.
  - name: ForumService
    description: Base class for RESTful services.
  - name: LanguageService
    description: |-
      Provides a RESTful interface to the Language services for language
      tags and, language bundles, and language data for Agilquest.
  - name: LocaleService
    description: >-
      The Locale Service provides TimeZone and LanguageData information about
      the

      Agilquest.
  - name: LocationService
    description: |-
      The Location Service provides an interface for interacting with Locations
      and Locator Structures in the Agilquest.
  - name: LookupService
    description: |-
      The lookup service exposes the code table lookup functionality of the
      Agilquest.
  - name: PropertiesService
    description: Retrieves the properties associated with a given account.
  - name: ReservationEventViewsService
    description: >-
      The Reservation Event View Service provides views of Reservation events
      (ReservationGroup).
  - name: ReservationService
    description: |-
      The Reservation Service handles creating, changing, and retrieving
      reservations through the ReservationServiceBusiness interface.
  - name: ReservationViewsService
    description: |-
      The Reservation View Service provides views into the existing reservation
      information maintained by the Agilquest.
  - name: ResourceGroupService
    description: |-
      The Resource Group service provides an interface into manipulating
      the resource groups in the Agilquest.
  - name: ResourceService
    description: Base class for RESTful services.
  - name: ResourceViewsService
    description: |-
      The Resource Views service provides views into existing resources in
      the Agilquest.
  - name: ReviewsService
    description: Base class for RESTful services.
  - name: RoomConfigurationService
    description: Base class for RESTful services.
  - name: SplashPageService
    description: Base class for RESTful services.
  - name: SystemService
    description: System Service.
  - name: UserGroupService
    description: Base class for RESTful services.
  - name: UserService
    description: |-
      The User Service provides an interface for adding, editing, and removing
      users in the Agilquest.
  - name: UserViewsService
    description: |-
      The User Views service provides views into the existing User information
      maintained by the Agilquest.
  - name: VisitorService
    description: >-
      The Visitor Service provides an interface for adding, editing, and
      removing

      visitors in the Agilquest.
paths:
  /reservations/recurring-dates/calculate-last-date:
    post:
      tags:
        - ReservationService
      description: >-
        This operation calculates the end date for the given Recurrence Rule
        provided and returns the corresponding AqDate value.


        If the recurrence rule is has no end date, an AqNoEndDate value is
        returned.


        This operation requires a Recurrence Rule value.


        This operation returns an AqDate value.
      operationId: getLastRecurrenceDate
      parameters: []
      requestBody:
        required: false
        content:
          application/json:
            examples:
              example:
                value:
                  aqEndDate:
                    discriminator: AqDate
                    hour: 12345
                    tzIdValue: ...
                    year: 12345
                    month: 12345
                    dayOfMonth: 12345
                    minute: 12345
                    noEndDate: true
                  sysidRecurrencePatternType: 12345
                  onSaturday: true
                  onMonday: true
                  onTuesday: true
                  sysidRecurrenceRule: 12345
                  onSunday: true
                  occurrences: 12345
                  sysidMonthlyDayOccurrenceType: 12345
                  theDate: 12345
                  onThursday: true
                  sysidMonthlyDayType: 12345
                  onFriday: true
                  aqStartDate:
                    discriminator: AqDate
                    hour: 12345
                    tzIdValue: ...
                    year: 12345
                    month: 12345
                    dayOfMonth: 12345
                    minute: 12345
                    noEndDate: true
                  onWednesday: true
                  exceptions:
                    - sysidReservation: 12345
                      exceptionType: EXCEPTION
                      relatedSysid: 12345
                      sysidRecurrenceRuleException: 12345
                      reservationDate: 12345
                    - sysidReservation: 12345
                      exceptionType: RESERVATION
                      relatedSysid: 12345
                      sysidRecurrenceRuleException: 12345
                      reservationDate: 12345
                  interval: 12345
            schema:
              $ref: '#/components/schemas/RecurrenceRule'
      responses:
        '201':
          content:
            application/json:
              examples:
                example:
                  value:
                    discriminator: AqDate
                    hour: 12345
                    tzIdValue: ...
                    year: 12345
                    month: 12345
                    dayOfMonth: 12345
                    minute: 12345
                    noEndDate: true
              schema:
                $ref: '#/components/schemas/AqDate'
          description: >-
            AqDate last occurrence date in recurrence rule, or
            AqDate.NO_END_DATE if recurrence has no end date.
components:
  schemas:
    RecurrenceRule:
      type: object
      title: RecurrenceRule
      required:
        - sysidRecurrencePatternType
      allOf:
        - $ref: '#/components/schemas/DependentData'
        - properties:
            aqEndDate:
              $ref: '#/components/schemas/AqDate'
            sysidRecurrencePatternType:
              type: integer
              format: int32
            onSaturday:
              type: boolean
            onMonday:
              type: boolean
            onTuesday:
              type: boolean
            sysidRecurrenceRule:
              type: integer
              format: int32
            onSunday:
              type: boolean
            occurrences:
              type: integer
              format: int32
            sysidMonthlyDayOccurrenceType:
              type: integer
              format: int32
            theDate:
              type: integer
              format: int32
            onThursday:
              type: boolean
            sysidMonthlyDayType:
              type: integer
              format: int32
            onFriday:
              type: boolean
            aqStartDate:
              $ref: '#/components/schemas/AqDate'
            onWednesday:
              type: boolean
            exceptions:
              type: array
              items:
                $ref: '#/components/schemas/RecurrenceException'
            interval:
              type: integer
              format: int32
      example:
        aqEndDate:
          discriminator: AqDate
          hour: 12345
          tzIdValue: ...
          year: 12345
          month: 12345
          dayOfMonth: 12345
          minute: 12345
          noEndDate: true
        sysidRecurrencePatternType: 12345
        onSaturday: true
        onMonday: true
        onTuesday: true
        sysidRecurrenceRule: 12345
        onSunday: true
        occurrences: 12345
        sysidMonthlyDayOccurrenceType: 12345
        theDate: 12345
        onThursday: true
        sysidMonthlyDayType: 12345
        onFriday: true
        aqStartDate:
          discriminator: AqDate
          hour: 12345
          tzIdValue: ...
          year: 12345
          month: 12345
          dayOfMonth: 12345
          minute: 12345
          noEndDate: true
        onWednesday: true
        exceptions:
          - sysidReservation: 12345
            exceptionType: RESERVATION
            relatedSysid: 12345
            sysidRecurrenceRuleException: 12345
            reservationDate: 12345
          - sysidReservation: 12345
            exceptionType: EXCEPTION
            relatedSysid: 12345
            sysidRecurrenceRuleException: 12345
            reservationDate: 12345
        interval: 12345
    AqDate:
      discriminator: discriminator
      type: object
      title: AqDate
      required:
        - hour
        - year
        - month
        - dayOfMonth
        - minute
        - noEndDate
      allOf:
        - $ref: '#/components/schemas/DependentData'
        - properties:
            discriminator:
              description: The JSON object type.
              type: string
            hour:
              type: integer
              format: int32
            tzIdValue:
              type: string
            year:
              type: integer
              format: int32
            month:
              type: integer
              format: int32
            dayOfMonth:
              type: integer
              format: int32
            minute:
              type: integer
              format: int32
            noEndDate:
              type: boolean
      example:
        discriminator: AqDate
        hour: 12345
        tzIdValue: ...
        year: 12345
        month: 12345
        dayOfMonth: 12345
        minute: 12345
        noEndDate: true
    DependentData:
      type: object
      title: DependentData
      example: {}
    RecurrenceException:
      type: object
      title: RecurrenceException
      allOf:
        - $ref: '#/components/schemas/DependentData'
        - properties:
            sysidReservation:
              type: integer
              format: int64
            exceptionType:
              $ref: '#/components/schemas/RecurrenceExceptionType'
            relatedSysid:
              type: integer
              format: int64
            sysidRecurrenceRuleException:
              type: integer
              format: int32
            reservationDate:
              type: integer
              format: int32
      example:
        sysidReservation: 12345
        exceptionType: CALENDAR
        relatedSysid: 12345
        sysidRecurrenceRuleException: 12345
        reservationDate: 12345
    RecurrenceExceptionType:
      type: string
      title: RecurrenceExceptionType
      enum:
        - RESERVATION
        - CALENDAR
        - EXCEPTION

````